/*------------------------------------------------------------------------
Program Name: lcase.c
Author:       Jeff Barnes
(c) 1988 by   Database Design
              500 North Grape  Suite 127
              Escondido, CA 92025
              Compuserve 76526,2141

Revision: 1.0 Last Revised: 10/22/1988 at 22:39

Notes: converts all upper case chars to lower case
       compile with MSC 5.1

------------------------------- PUBLIC DOMAIN --------------------------*/

#include <stdio.h>
#include <io.h>
#include <stdlib.h>

static char *copyright = "LCASE 1.0 Copyright (c) 1988 Jeff Barnes, Database Design";
FILE  *in;
FILE  *out;
int c;
int lc = 0;
static char *template = "lcasXXXXXX";

void main( int argc, char *argv[] )
{
   printf( "\n%s\n\n", copyright );
   if ( argc < 2 ) {
      printf( "Syntax -- lcase file.ext \n" );
      printf( "This will convert all upper case chars to lower.\n" );
      printf( "Make sure you run it on  a text file, because the \n" );
      printf( "program has no way of knowing. For example if you \n" );
      printf( "run it on an EXE or COM file, you will just trash it. \n" );
      printf( "WARNING !!!! \n" );
      printf( "Does not make a back-up file. \n" );
      exit( 1 );
      }

   if (( in = fopen( argv[1], "r+" )) == NULL) {
      printf( "Can't open %s \nQuitting \n\a", argv[1]);
      exit( 1 );
      }

   if ( mktemp( template ) == NULL ){
      printf( "Can't create unique file name \nQuitting \a\n" );
      exit( 1 );
      }

   if (( out = fopen( template, "w+" )) == NULL) {
      printf( "Can't open temporary file \nQuitting \n\a" );
      exit( 1 );
      }

   while ( ( c = getc( in )) != EOF ){
      if( c > 0x40 && c < 0x5B )
          c = c + 0x20;
      if( fprintf( out,"%c",c) != 1 ) {
         printf( "Error creating new file \nQuitting \n\a" );
         exit( 1 );
         }
      }

   fclose( in );
   fclose( out );

   if (( remove( argv[1] )) == 0 ){
      if (( rename( template, argv[1] )) == 0 )
         printf( "All done \n\a" );
      }
}
